// date.cpp implementacija ddx funkcije i jedne pomocne funkcije

#include "stdafx.h"
#include "date.h"


void DDX_Date (CDataExchange *pDX, UINT nID, CTime& datevar)
{
	if ( pDX->m_bSaveAndValidate ) 
    { // podatak ide iz kontrole u promenljivu
		BOOL bValid = TRUE;
		CString strDate;
		pDX->PrepareEditCtrl( nID ); // zapamti gde smo ako validacija ne uspe
        pDX->m_pDlgWnd->GetDlgItem( nID )->GetWindowText( strDate ); // uzmi tekst iz edit boxa
        int nMonth, nDay, nYear;
		if ( (sscanf( strDate,"%2d.%2d.%2d", &nDay, &nMonth, &nYear )) !=3 ) 
	   		bValid = FALSE; // konvertuj string u brojevnu reprezentaciju a ako ne uspe signaliziraj odmah
        else
		{// datum je bar sintaksno ispravan, proveri mu smisao
			if ( !ValidDate(nYear,nMonth,nDay) )
				bValid = FALSE;
		}

		if ( bValid == FALSE ) // datum nije ispravan
		{
			AfxMessageBox ( "Molim unesite datum u formatu dd.MM.yy" ); // prikazi upozorenje
            pDX->Fail( ); // oznaci neuspelu validaciju
            return;
		}
		else // datum je ok, spremi ga u promenljivu
		{
			if ( nYear < 71 ) // CTime pamti samo range 2.1.1970-18.1.2038
			{
				if( nYear < 38) // posle dvehiljadite :))
					nYear += 2000;
				else
				{
					AfxMessageBox ( "Molim unesite datum u intervalu 1.1.1971 - 1.1.2037" ); // jos 40 godina...
					pDX->Fail( ); // oznaci neuspelu validaciju
					return;
				}
			}
			else nYear += 1900; // jos uvek dvadeseti vek
			CTime date( nYear, nMonth, nDay, 0, 0, 0 );
			datevar = date; // smesti vrednost u promenljivu
		}
    }
    else
    { // podatak ide iz promenljive u dijalog
		CString strDate;
		strDate=datevar.Format("%d.%m.%y" ); // pretvori datum u string...
		pDX->m_pDlgWnd->GetDlgItem( nID )->SetWindowText( strDate ); //...i smesti ga u kontrolu
    }
}

BOOL ValidDate (int& iYear, int& iMonth, int& iDay)
{
  if (iDay  < 1 || iMonth < 1 || iMonth > 12 ||
      iYear < 0 || iYear > 99)
    return FALSE;

  switch (iMonth)
  {
    case 4:
    case 6:
    case 9:
    case 11:
		if (iDay > 30)
			return (FALSE);
		break;
      
    case 2:
		if (iYear % 4   == 0 && iYear % 100 != 0 || 
			iYear % 400 == 0)
		{
			if (iDay > 29)
				return FALSE;
		}
		else
		{
			if (iDay > 28)
				return FALSE;
		}
		break;

    default:              
		if (iDay > 31)
			return FALSE;
		break;
  }
  return TRUE;
}
